diff -ruN ../nakedmudv3.0/src/handler.c src/handler.c
--- ../nakedmudv3.0/src/handler.c	Fri Oct  7 14:55:09 2005
+++ src/handler.c	Sun Dec  4 20:03:07 2005
@@ -44,7 +44,7 @@
   propertyTablePut(obj_table, obj);
 
   // execute all of our to_game hooks
-  hookRun("obj_to_game", obj, NULL, NULL);
+  hookRun("obj_to_game", obj);
 
   // also add all contents
   if(listSize(objGetContents(obj)) > 0) {
@@ -61,7 +61,7 @@
   propertyTablePut(room_table, room);
 
   // execute all of our to_game hooks
-  hookRun("room_to_game", room, NULL, NULL);
+  hookRun("room_to_game", room);
 
   // add contents
   if(listSize(roomGetContents(room)) > 0) {
@@ -100,7 +100,7 @@
   propertyTablePut(mob_table, ch);
 
   // execute all of our to_game hooks
-  hookRun("char_to_game", ch, NULL, NULL);
+  hookRun("char_to_game", ch);
 
   // also add inventory
   if(listSize(charGetInventory(ch)) > 0) {
@@ -132,7 +132,7 @@
   propertyTableRemove(obj_table, objGetUID(obj));
 
   // go through all of our fromgame hooks
-  hookRun("obj_from_game", obj, NULL, NULL);
+  hookRun("obj_from_game", obj);
 
   // also remove everything that is contained within the object
   if(listSize(objGetContents(obj)) > 0) {
@@ -149,7 +149,7 @@
   propertyTableRemove(room_table, roomGetUID(room));
 
   // go through all of our fromgame hooks
-  hookRun("room_from_game", room, NULL, NULL);
+  hookRun("room_from_game", room);
 
   // also remove all the objects contained within the room
   if(listSize(roomGetContents(room)) > 0) {
@@ -184,7 +184,7 @@
   propertyTableRemove(mob_table, charGetUID(ch));
 
   // go through all of our fromgame hooks
-  hookRun("char_from_game", ch, NULL, NULL);
+  hookRun("char_from_game", ch);
 
   // also remove inventory
   if(listSize(charGetInventory(ch)) > 0) {
@@ -292,7 +292,7 @@
 	    "$n gets $o.");
     obj_from_room(obj);
     obj_to_char(obj, ch);
-    hookRun("get", ch, obj, NULL);
+    hookRun("get", ch, obj);
   }
 }
 
@@ -334,13 +334,12 @@
 
 void do_drop(CHAR_DATA *ch, OBJ_DATA *obj) {
   send_to_char(ch, "You drop %s.\r\n", objGetName(obj));
-  message(ch, NULL, obj, NULL, TRUE, TO_ROOM,
-	  "$n drops $o.");
+  message(ch, NULL, obj, NULL, TRUE, TO_ROOM, "$n drops $o.");
   obj_from_char(obj);
   obj_to_room(obj, charGetRoom(ch));
 
   // run all of our drop hooks
-  hookRun("drop", ch, obj, NULL);
+  hookRun("drop", ch, obj);
 }
 
 
@@ -349,8 +348,10 @@
     send_to_char(ch, "You cannot wear %s!\r\n", objGetName(obj));
   else {
     obj_from_char(obj);
-    if(try_equip(ch, obj, where))
-      send_to_char(ch, "You equip %s.\r\n", objGetName(obj));
+    if(try_equip(ch, obj, where, wornGetPositions(obj))) {
+      message(ch, NULL, obj, NULL, TRUE, TO_CHAR, "You equip $o.");
+      message(ch, NULL, obj, NULL, TRUE, TO_ROOM, "$n equips $o.");
+    }
     else {
       send_to_char(ch, "You could not equip %s.\r\n", objGetName(obj));
       obj_to_char(obj, ch);
@@ -361,7 +362,8 @@
 
 void do_remove(CHAR_DATA *ch, OBJ_DATA *obj) {
   if(try_unequip(ch, obj)) {
-    send_to_char(ch, "You remove %s.\r\n", objGetName(obj));
+    message(ch, NULL, obj, NULL, TRUE, TO_CHAR, "You remove $o.");
+    message(ch, NULL, obj, NULL, TRUE, TO_ROOM, "$n removes $o.");
     obj_to_char(obj, ch);
   }
   else
@@ -373,73 +375,62 @@
 //*****************************************************************************
 // functions related to equipping and unequipping items
 //*****************************************************************************
-bool try_equip(CHAR_DATA *ch, OBJ_DATA *obj, const char *poslist) {
-  if(!objIsType(obj, "worn"))
-    return FALSE;
-
-  bool success       = FALSE;
-  char *wanted       = NULL;
-  const char *needed = NULL;
-
-  // get a list of the position types we need to equip to
-
-  // see where we _want_ to equip to
-  if(poslist && *poslist)
-    wanted = list_postypes(charGetBody(ch), poslist);
-  needed = wornGetPositions(obj);
-
-  // just equip to the first free slots
-  if(!wanted)
-    success = bodyEquipPostypes(charGetBody(ch), obj, needed);
-  // check to see if all the positions we want to equip to match up with
-  // what we need to equip to
-  else {
+bool try_equip(CHAR_DATA *ch, OBJ_DATA *obj, const char *wanted_pos,
+	       const char *required_pos) {
+  bool success = FALSE;
+
+  // if we don't need any specific places, try equipping to our wanted spots
+  if(!required_pos || !*required_pos)
+    success = bodyEquipPosnames(charGetBody(ch), obj, wanted_pos);
+
+  // if we don't want any specific places, equip to whatever is open
+  else if(!wanted_pos || !*wanted_pos)
+    success = bodyEquipPostypes(charGetBody(ch), obj, required_pos);
+
+  // otherwise, see if the places we want to equip to match what we need,
+  // and also make sure we're not trying to equip the same position twice
+  else if(!dup_keywords_exist(wanted_pos)) {
     // build lists of what we want and what we need, and compare
-    int i, j, num_want = 0, num_need = 0;
-    char **want_names, **need_names;
-    bool match = FALSE;
-    want_names = parse_keywords(wanted, &num_want);
-    need_names = parse_keywords(needed, &num_need); 
-
-    // try to match it all up
-    if(num_want == num_need) {
-      // assume true, and try to find two that mismatch
-      match = TRUE;
-      for(i = 0; i < num_want; i++) {
-	bool found = FALSE;
-	for(j = 0; j < num_need; j++) {
-	  if(need_names[j] && !strcmp(want_names[i], need_names[j])) {
-	    // use one up
-	    free(need_names[j]); 
-	    need_names[j] = NULL;
-	    found = TRUE;
-	    break;
-	  }
-	}
-	if(!found) {
-	  match = FALSE;
+    char *want_type_list = list_postypes(charGetBody(ch), wanted_pos);
+    LIST     *want_types = parse_keywords(want_type_list); 
+    LIST     *need_types = parse_keywords(required_pos);
+    bool           match = TRUE;
+
+    // make sure we have both wanted and needed positions
+    // and then try to match it all up
+    if(listSize(want_types) != listSize(need_types))
+      match = FALSE;
+    else {
+      LIST_ITERATOR *need_i = newListIterator(need_types);
+      char        *one_need = NULL;
+
+      // now, make sure that each our our needed positions is represented
+      ITERATE_LIST(one_need, need_i) {
+	char *found = listRemoveWith(want_types, one_need, strcasecmp);
+	// if we found it, free the memory. Otherwise, break out and fail
+	if(found == NULL)
 	  break;
-	}
-      }
-    }
+	else
+	  free(found);
+      } deleteListIterator(need_i);
 
-    // try to equip
-    if(match)
-      success = bodyEquipPosnames(charGetBody(ch), obj, poslist);
-
-    // free everything up
-    for(i = 0; i < num_want || i < num_need; i++) {
-      if(want_names[i]) free(want_names[i]);
-      if(need_names[i]) free(need_names[i]);
+      // make sure we accounted for all of our needed positions
+      match = (listSize(want_types) == 0);
     }
-    if(want_names) free(want_names);
-    if(need_names) free(need_names);
+
+    // garbage collection
+    if(want_type_list) free(want_type_list);
+    deleteListWith(want_types, free);
+    deleteListWith(need_types, free);
+
+    // if we didn't run into problems, try equipping
+    if(match == TRUE)
+      success = bodyEquipPosnames(charGetBody(ch), obj, wanted_pos);
   }
 
-  if(wanted) free(wanted);
-  if(success) {
+  if(success == TRUE) {
     objSetWearer(obj, ch);
-    hookRun("wear", ch, obj, NULL);
+    hookRun("wear", ch, obj);
   }
   return success;
 }
@@ -447,7 +438,7 @@
 bool try_unequip(CHAR_DATA *ch, OBJ_DATA *obj) {
   if(bodyUnequip(charGetBody(ch), obj)) {
     objSetWearer(obj, NULL);
-    hookRun("remove", ch, obj, NULL);
+    hookRun("remove", ch, obj);
     return TRUE;
   }
   return FALSE;
@@ -462,7 +453,7 @@
   while( (obj = listPop(eq)) != NULL) {
     if(bodyUnequip(charGetBody(ch), obj)) {
       objSetWearer(obj, NULL);
-      hookRun("remove", ch, obj, NULL);
+      hookRun("remove", ch, obj);
       obj_to_char(obj, ch);
     }
   } deleteList(eq);
diff -ruN ../nakedmudv3.0/src/handler.h src/handler.h
--- ../nakedmudv3.0/src/handler.h	Fri Oct  7 14:15:55 2005
+++ src/handler.h	Sun Dec  4 20:03:07 2005
@@ -51,7 +51,8 @@
 void      char_from_furniture (CHAR_DATA *ch);
 void      char_to_furniture   (CHAR_DATA *ch, OBJ_DATA *furniture);
 
-bool      try_equip         (CHAR_DATA *ch, OBJ_DATA *obj, const char *poslist);
+bool      try_equip         (CHAR_DATA *ch, OBJ_DATA *obj, 
+			     const char *wanted_pos, const char *required_pos);
 bool      try_unequip       (CHAR_DATA *ch, OBJ_DATA *obj);
 void      unequip_all       (CHAR_DATA *ch);
 
diff -ruN ../nakedmudv3.0/src/hashtable.c src/hashtable.c
--- ../nakedmudv3.0/src/hashtable.c	Fri Oct  7 14:15:55 2005
+++ src/hashtable.c	Sun Dec  4 20:03:07 2005
@@ -63,7 +63,7 @@
     return NULL;
   else {
     LIST_ITERATOR *list_i = newListIterator(table->buckets[bucket]);
-    HASH_ENTRY *elem = NULL;
+    HASH_ENTRY      *elem = NULL;
 
     for(;(elem = listIteratorCurrent(list_i)) != NULL; listIteratorNext(list_i))
       if(!strcasecmp(key, elem->key))
@@ -227,25 +227,7 @@
 }
 
 int   hashIn     (HASHTABLE *table, const char *key) {
-  int bucket = hash(key) % table->num_buckets;
-
-  if(table->buckets[bucket] == NULL)
-    return 0;
-  else {
-    int found  = 0;
-    LIST_ITERATOR *list_i = newListIterator(table->buckets[bucket]);
-    HASH_ENTRY *elem = NULL;
-
-    for(;(elem = listIteratorCurrent(list_i)) != NULL;listIteratorNext(list_i)){
-      if(!strcasecmp(key, elem->key)) {
-	found = 1;
-	break;
-      }
-    }
-    deleteListIterator(list_i);
-
-    return found;
-  }
+  return (hashGetEntry(table, key) != NULL);
 }
 
 int   hashSize   (HASHTABLE *table) {
@@ -265,6 +247,25 @@
     deleteListIterator(list_i);
   }
   return list;
+}
+
+void hashClear(HASHTABLE *table) {
+  hashClearWith(table, NULL);
+}
+
+void hashClearWith(HASHTABLE *table, void *func) {
+  void (* free_func)(void *) = func;
+  int i;
+
+  for(i = 0; i < table->num_buckets; i++) {
+    if(table->buckets[i] == NULL) continue;
+    HASH_ENTRY *elem = NULL;
+    while( (elem = listPop(table->buckets[i])) != NULL) {
+      if(free_func && elem->val)
+	free_func(elem->val);
+      deleteHashtableEntry(elem);
+    }
+  }
 }
 
 
diff -ruN ../nakedmudv3.0/src/hashtable.h src/hashtable.h
--- ../nakedmudv3.0/src/hashtable.h	Fri Oct  7 14:15:55 2005
+++ src/hashtable.h	Sun Dec  4 20:03:07 2005
@@ -40,6 +40,15 @@
 // must be deleted after use. Try: deleteListWith(list, free)
 LIST *hashCollect(HASHTABLE *table);
 
+//
+// clears all of the contents of the hashtable
+void hashClear(HASHTABLE *table);
+
+//
+// clears all of the contents of the hashtable, and deletes the vals with the
+// specified function. NULL indicates no delection
+void hashClearWith(HASHTABLE *table, void *func);
+
 
 
 //*****************************************************************************
diff -ruN ../nakedmudv3.0/src/help/help.c src/help/help.c
--- ../nakedmudv3.0/src/help/help.c	Fri Oct  7 14:15:55 2005
+++ src/help/help.c	Sun Dec  4 20:03:07 2005
@@ -161,20 +161,22 @@
 // add a helpfile to the help table. Assocciate all of its keywords with it
 //
 void add_help(HELP_DATA *help) {
-  int num_keywords = 0;
-  char  **keywords = parse_keywords(help->keywords, &num_keywords);
-  int i;
-  for(i = 0; i < num_keywords; i++) {
-    LIST *row = help_table[helpbucket(keywords[i])];
-    HELP_ENTRY *new_entry = newHelpEntry(keywords[i], help);
+  LIST       *keywords = parse_keywords(help->keywords);
+  LIST_ITERATOR *key_i = newListIterator(keywords);
+  char            *key = NULL;
+
+  ITERATE_LIST(key, key_i) {
+    LIST *row = help_table[helpbucket(key)];
+    HELP_ENTRY *new_entry = newHelpEntry(key, help);
     HELP_ENTRY *old_entry = NULL;
     // make sure we're not already in the help table
     if((old_entry = listRemoveWith(row, new_entry, hentrycmp)) != NULL)
       deleteHelpEntry(old_entry);
     listPutWith(row, new_entry, hentrycmp);
-    free(keywords[i]);
-  }
-  free(keywords);
+  } deleteListIterator(key_i);
+
+  // garbage collection
+  deleteListWith(keywords, free);
 }
 
 
diff -ruN ../nakedmudv3.0/src/hooks.c src/hooks.c
--- ../nakedmudv3.0/src/hooks.c	Fri Oct  7 14:15:55 2005
+++ src/hooks.c	Sun Dec  4 20:03:07 2005
@@ -30,14 +30,49 @@
 // the table of all our installed hooks
 HASHTABLE *hook_table = NULL;
 
+// a table of all our handlers for running hooks
+HASHTABLE *hook_handler_table = NULL;
+
 
 
 //*****************************************************************************
 // implementation of hooks.h
 //*****************************************************************************
 void init_hooks(void) {
-  // make our table of hooks
-  hook_table = newHashtable();
+  // make our required tables
+  hook_handler_table = newHashtable();
+  hook_table         = newHashtable();
+
+  // set up our basic types of hooks
+  hook_add_handler("shutdown",             hook_handler_0_args);
+  hook_add_handler("create_account",       hook_handler_1_arg);
+  hook_add_handler("create_player",        hook_handler_1_arg);
+  hook_add_handler("enter",                hook_handler_2_args);
+  hook_add_handler("exit",                 hook_handler_3_args);
+  hook_add_handler("ask",                  hook_handler_3_args);
+  hook_add_handler("say",                  hook_handler_2_args);
+  hook_add_handler("greet",                hook_handler_2_args);
+  hook_add_handler("obj_to_game",          hook_handler_1_arg);
+  hook_add_handler("char_to_game",         hook_handler_1_arg);
+  hook_add_handler("room_to_game",         hook_handler_1_arg);
+  hook_add_handler("obj_from_game",        hook_handler_1_arg);
+  hook_add_handler("char_from_game",       hook_handler_1_arg);
+  hook_add_handler("room_from_game",       hook_handler_1_arg);
+  hook_add_handler("get",                  hook_handler_2_args);
+  hook_add_handler("give",                 hook_handler_3_args);
+  hook_add_handler("drop",                 hook_handler_2_args);
+  hook_add_handler("wear",                 hook_handler_2_args);
+  hook_add_handler("remove",               hook_handler_2_args);
+  hook_add_handler("reset",                hook_handler_1_arg);
+  hook_add_handler("open_door",            hook_handler_2_args);
+  hook_add_handler("open_obj",             hook_handler_2_args);
+  hook_add_handler("close_door",           hook_handler_2_args);
+  hook_add_handler("close_obj",            hook_handler_2_args);
+}
+
+void hook_add_handler(const char *type, 
+		      void (* handler)(LIST *hooks, va_list args)) {
+  hashPut(hook_handler_table, type, handler);
 }
 
 void hookAdd(const char *type, void *hook) {
@@ -49,18 +84,96 @@
   listQueue(list, hook);
 }
 
-void hookRun(const char *type, void *actor, void *acted, void *arg) {
+void hookRun(const char *type, ...) {
   LIST *list = hashGet(hook_table, type);
-  if(list != NULL) {
-    LIST_ITERATOR *hook_i = newListIterator(list);
-    void (* hook)(void *actor, void *acted, void *arg) = NULL;
-    ITERATE_LIST(hook, hook_i)
-      hook(actor, acted, arg);
-    deleteListIterator(hook_i);
+  void (* handler)(LIST *hooks, va_list args) = 
+    hashGet(hook_handler_table, type);
+  if(list != NULL && handler != NULL) {
+    va_list args;
+    va_start(args, type);
+    handler(list, args);
+    va_end(args);
   }
 }
 
 void hookRemove(const char *type, void *hook) {
   LIST *list = hashGet(hook_table, type);
   if(list != NULL) listRemove(list, hook);
+}
+
+void hook_handler_0_args(LIST *hooks, va_list args) {
+  LIST_ITERATOR *hook_i = newListIterator(hooks);
+  void   (* hook)(void) = NULL;
+  ITERATE_LIST(hook, hook_i) {
+    hook();
+  } deleteListIterator(hook_i);
+}
+
+void hook_handler_1_arg(LIST *hooks, va_list args) {
+  LIST_ITERATOR *hook_i = newListIterator(hooks);
+  void *arg1 = va_arg(args, void *);
+  void (* hook)(void *) = NULL;
+  ITERATE_LIST(hook, hook_i) {
+    hook(arg1);
+  } deleteListIterator(hook_i);
+}
+
+void hook_handler_2_args(LIST *hooks, va_list args) {
+  LIST_ITERATOR *hook_i = newListIterator(hooks);
+  void *arg1 = va_arg(args, void *);
+  void *arg2 = va_arg(args, void *);
+  void (* hook)(void *, void *) = NULL;
+  ITERATE_LIST(hook, hook_i) {
+    hook(arg1, arg2);
+  } deleteListIterator(hook_i);
+}
+
+void hook_handler_3_args(LIST *hooks, va_list args) {
+  LIST_ITERATOR *hook_i = newListIterator(hooks);
+  void *arg1 = va_arg(args, void *);
+  void *arg2 = va_arg(args, void *);
+  void *arg3 = va_arg(args, void *);
+  void (* hook)(void *, void *, void *) = NULL;
+  ITERATE_LIST(hook, hook_i) {
+    hook(arg1, arg2, arg3);
+  } deleteListIterator(hook_i);
+}
+
+void hook_handler_4_args(LIST *hooks, va_list args) {
+  LIST_ITERATOR *hook_i = newListIterator(hooks);
+  void *arg1 = va_arg(args, void *);
+  void *arg2 = va_arg(args, void *);
+  void *arg3 = va_arg(args, void *);
+  void *arg4 = va_arg(args, void *);
+  void (* hook)(void *, void *, void *, void *) = NULL;
+  ITERATE_LIST(hook, hook_i) {
+    hook(arg1, arg2, arg3, arg4);
+  } deleteListIterator(hook_i);
+}
+
+void hook_handler_5_args(LIST *hooks, va_list args) {
+  LIST_ITERATOR *hook_i = newListIterator(hooks);
+  void *arg1 = va_arg(args, void *);
+  void *arg2 = va_arg(args, void *);
+  void *arg3 = va_arg(args, void *);
+  void *arg4 = va_arg(args, void *);
+  void *arg5 = va_arg(args, void *);
+  void (* hook)(void *, void *, void *, void *, void *) = NULL;
+  ITERATE_LIST(hook, hook_i) {
+    hook(arg1, arg2, arg3, arg4, arg5);
+  } deleteListIterator(hook_i);
+}
+
+void hook_handler_6_args(LIST *hooks, va_list args) {
+  LIST_ITERATOR *hook_i = newListIterator(hooks);
+  void *arg1 = va_arg(args, void *);
+  void *arg2 = va_arg(args, void *);
+  void *arg3 = va_arg(args, void *);
+  void *arg4 = va_arg(args, void *);
+  void *arg5 = va_arg(args, void *);
+  void *arg6 = va_arg(args, void *);
+  void (* hook)(void *, void *, void *, void *, void *, void *) = NULL;
+  ITERATE_LIST(hook, hook_i) {
+    hook(arg1, arg2, arg3, arg4, arg5, arg6);
+  } deleteListIterator(hook_i);
 }
diff -ruN ../nakedmudv3.0/src/hooks.h src/hooks.h
--- ../nakedmudv3.0/src/hooks.h	Fri Oct  7 14:15:55 2005
+++ src/hooks.h	Sun Dec  4 20:03:07 2005
@@ -25,27 +25,39 @@
 void init_hooks(void);
 
 //
-// This function attaches a hook to the game. It will run whenever a signal is
-// sent that a hook of "type" should run. Hooks take three arguments, some of
-// which may be null depending on the hook:
-//   void hook(actor, acted, arg)
-//
-// actor is the thing taking an action which is causing the hook to execute.
-// For instance, a character asking something for an "ask" hook.
-// 
-// acted is the thing being acted upon. For instance, the person being asked
-// a question in an "ask" hook.
+// creates a "middle-man" between hooks and the variables passed in when 
+// hookRun is called. The supplied function should take a LIST of hooks to
+// be run, and a VA_LIST of arguments. It should parse the arguments out of
+// VA_LIST and call each hook in the LIST with the arguments found in VA_LIST.
+void hook_add_handler(const char *type, 
+		      void(* handler)(LIST *hooks, va_list args));
+
 //
-// arg is some argument to the hook. Its type is determined by the type of
-// hook it is. In the example of the "ask" hook, this might be the question
-// being asked.
+// some handlers for use by outside modules not wanting to write their own hook
+// handlers. Each assumes a specific number of (void *) pointer arguments, and
+// no return value. If you want to support arguments of other sizes (like ints,
+// bools, etc) or would like your hooks to be able to return values, you will
+// have to write your own handler.
+void hook_handler_0_args(LIST *hooks, va_list args);
+void  hook_handler_1_arg(LIST *hooks, va_list args);
+void hook_handler_2_args(LIST *hooks, va_list args);
+void hook_handler_3_args(LIST *hooks, va_list args);
+void hook_handler_4_args(LIST *hooks, va_list args);
+void hook_handler_5_args(LIST *hooks, va_list args);
+void hook_handler_6_args(LIST *hooks, va_list args);
+
 //
-// init_hooks must be called before this function can be used.
+// This function attaches a hook to the game. It will run whenever a signal is
+// sent that a hook of "type" should run. A hook is a function. The number and
+// types of arguments that the function should take, as well as the type of 
+// return value the hook should supply depends on the type of hook it's added as
 void hookAdd(const char *type, void *hook);
 
 //
-// executes all of the hooks of the given type, with the given arguments.
-void hookRun(const char *type, void *actor, void *acted, void *arg);
+// executes all of the hooks of the given type, with the given arguments. This
+// is sort of a sloppy way to provide hooks with arguments, but it's the best
+// I've come up with so far.
+void hookRun(const char *type, ...);
 
 //
 // remove the given hook
